
;; version simple
;; la valeur de x1 est à la fin de la liste
(define (expr-1 L)
  (let ( (x3 (car L))
         (x2 (car (cdr L)))
         (x1 (car (cdr (cdr L))))
         )
    (and (or x1 x2)
         (or (not x1) x3)
         (or (not x2) x3)
         )))

(expr-1 '(#t #f #f))

;; explore en profondeur d'abord toutes les solutions possible
;; f est la formule logique
;; n le nombre de variable à instancier
;; L la liste des variables déjà instanciées
(define (explorer-rec f n L)
  (if (= n 0)
      (if (f L)
          (cons L '())   ;; une seule solution dans la liste résultat
          '())           ;; aucune solution dans la liste résultat
      (append  
       (explorer-rec f (- n 1) (cons #t L))     ;; réunion des solutions regroupant celle où la variable n est vraie  
       (explorer-rec f (- n 1) (cons #f L)))))  ;; et celle où elle est fausse

(define (explorer f n)
  (explorer-rec f n '()))

(explorer expr-1 3)
